/**
 * This class contains unit tests for validating the behavior of Apex classes
 * and triggers.
 *
 * Unit tests are class methods that verify whether a particular piece
 * of code is working properly. Unit test methods take no arguments,
 * commit no data to the database, and are flagged with the testMethod
 * keyword in the method definition.
 *
 * All test methods in an organization are executed whenever Apex code is deployed
 * to a production organization to confirm correctness, ensure code
 * coverage, and prevent regressions. All Apex classes are
 * required to have at least 75% code coverage in order to be deployed
 * to a production organization. In addition, all triggers must have some code coverage.
 * 
 * The @isTest class annotation indicates this class only contains test
 * methods. Classes defined with the @isTest annotation do not count against
 * the organization size limit for all Apex scripts.
 *
 * See the Apex Language Reference for more information about Testing and Code Coverage.
 */
  /*------------------------------------------------------------
Author:        Yen Le
Company:       Thirdwave
Description:   a test class created to validate the EquipmentTransferFormBulkClose,
                EquipmentTransferFormEdit, EquipmentTransferFormView, EquipmentTransferItemSelection
History: 	   31-Mar-15 Gangha Kaliyan To include facilities in Equipment Inventory
               09-Mar-17 Miro Zelina added Well Event and some fixes for facilities
               06-Jul-17 Miro Zelina added System & Sub-System
               28-Jul-17 Miro Zelina updated test for SAP Support User for bulk close
------------------------------------------------------------*/
@isTest
private class EquipmentTransferFormTest {

    static Field__c field;
    static Route__c route; 
    
    static void createSampleData()
    {
        
            Business_Unit__c businessUnit = new Business_Unit__c(Name = 'Test Business Unit');
            insert businessUnit;
    
            Business_Department__c  businessDepartment = BusinessDepartmentTestData.createBusinessDepartment('Test Business Department');    
            insert businessDepartment;
    
            Operating_District__c operatingDistrict = OperatingDistrictTestData.createOperatingDistrict('Test Field', businessDepartment.Id, businessUnit.Id);
            insert operatingDistrict;
            
            Id recordTypeId = [Select Id From RecordType Where SObjectType = 'Field__c' And Name = 'HOG - Control Room Centre Record'].Id;
            
            field = FieldTestData.createField('Test Field Control Centre', operatingDistrict.Id, recordTypeId);
            insert field;
    
            route = RouteTestData.createRoute('999');
            insert route; 
    }
    //test new/edit/view Equipment Transfer To/From Request
    static testMethod void testEquipmentTransferRequest()
    {
        User user = UserTestData.createTestUser();
        insert user;
        
        System.runAs(user)
        {
            createSampleData();
            Location__c loc1 = LocationTestData.createLocation('Location Source', route.Id, field.Id);
            insert loc1;
            Equipment__c equip = EquipmentTestData.createEquipment(loc1);
           
            Location__c loc2 = LocationTestData.createLocation('Location Destination', route.Id, field.Id);
            insert loc2;
            Equipment__c equip2 = EquipmentTestData.createEquipment(loc2);
            
            //test create a new Transfer Request from Loc2 to Loc1
            PageReference pageRef = Page.EquipmentTransferFormEdit;
            Test.setCurrentPage(pageRef);
            pageRef.getParameters().put('toLocId', loc2.Id);
            
            Equipment_Transfer_Form__c request = new Equipment_Transfer_Form__c();
            ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(request);
            EquipmentTransferFormControllerX transferCtrl = new EquipmentTransferFormControllerX(stdCtrl);
            request = transferCtrl.form;
            
            System.assertEquals(request.To_Location__c, loc2.Id);
            System.assertEquals(request.From_Location__c, null);
            //call getter methods 
            transferCtrl.getDestinationObjects();
            transferCtrl.onSelectDestination();
            transferCtrl.getLocOutputFieldFlag();
            transferCtrl.getFacOutputFieldFlag();
            transferCtrl.getEventOutputFieldFlag();
            transferCtrl.getDestInputFieldFlag();
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            request.Reason_for_Transfer_Additional_Details__c = 'NWC';
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            request.Date_of_Physical_Transfer__c = date.today();
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            request.Authorized_By__c = user.id;
            
            try 
            {
            	transferCtrl.Save();
            }
            catch(Exception e)
            {
            	System.assert(false, 'You must enter a value for To(Destination)');
            }
            
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'Please select at least one Equipment.');
            }
            
            //open the Manage Equipment page to select Equipment
            pageRef = Page.EquipmentTransferItemSelection;
            Test.setCurrentPage(pageRef);
            pageRef.getParameters().put('fromLocId', request.From_Location__c);
            pageRef.getParameters().put('toLocId', request.To_Location__c);
            pageRef.getParameters().put('equipId', transferCtrl.equipIds);
            EquipmentTransferItemSelectionController selectEquipCtrl = new EquipmentTransferItemSelectionController();
            
            //show all Equipments (2) because FROM Location isn't selected
            System.assertEquals(selectEquipCtrl.AvailableEquips.size(), 2);
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
            //back to Equipment Transfer Edit page
            selectEquipCtrl.onCancel();
            
            //test Form/To location is required
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            request.To_Location__c = null;
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            //populate FROM Location
            request.From_Location__c = loc1.Id;
            request.To_Location__c = loc2.Id;
            
            //open the Manage Equipment page again
            pageRef.getParameters().put('fromLocId', request.From_Location__c);
            pageRef.getParameters().put('toLocId', request.To_Location__c);
            pageRef.getParameters().put('equipId', transferCtrl.equipIds);
            selectEquipCtrl = new EquipmentTransferItemSelectionController();
            
            //should have one available Equipment 
            System.assertEquals(selectEquipCtrl.AvailableEquips.size(), 1);
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
            
            selectEquipCtrl.sortToggle();
            selectEquipCtrl.sortToggle();
            //add availble Equipment to shopping cart
            selectEquipCtrl.toSelect = equip.Id; 
            selectEquipCtrl.addToShoppingCart();
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 1);
            selectEquipCtrl.onSave();
            
            transferCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
            transferCtrl.addToEquipmentList();
            system.assertEquals(transferCtrl.equipmentList.size(), 1);
            
            
            //change FROM loc = To Location
            request.From_Location__c = request.To_Location__c;
            
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false,'Form Location has to be different from To Location.');
            }
            
            transferCtrl.resetEquipmentList();
            request.From_Location__c = loc1.Id;
            transferCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
            transferCtrl.addToEquipmentList();
             //upload attachment
            EquipmentItemWrapper item = transferCtrl.equipmentList[0];
            item.photo.Name = 'upload attachment';
            item.photo.Body = Blob.valueOf('pdf content');
         
            item.equipment.Tag_Colour__c = 'Red';
            transferCtrl.save();
            
            //test edit Equipment Transfer Request page
            request = [select Id, Authorized_By__c, Comments__c, Date_of_Physical_Transfer__c, Charge_No__c, From_Location__c, 
                        Maintenance_Work_Order__c, Reason_for_Transfer_Additional_Details__c, Shipped_Via__c, Status__c, 
                        To_Location__c, Waybill_No__c, From_Facility__c, To_Facility__c
                        from Equipment_Transfer_Form__c where Id =: request.Id];
                        
            pageRef = Page.EquipmentTransferFormEdit;
            Test.setCurrentPage(pageRef);
            pageRef.getParameters().put('id', request.Id);
            pageRef.getParameters().put('retURL', loc1.Id);
            
            stdCtrl = new ApexPages.Standardcontroller(request);
            EquipmentTransferFormControllerX transferFormEditCtrl = new EquipmentTransferFormControllerX(stdCtrl);
            System.assertEquals(transferFormEditCtrl.equipmentList.size(), 1);
            
            //delete attachment
            pageRef.getParameters().put('equipId', equip.Id);
            transferFormEditCtrl.DeletePhoto();
            
            //delete Equipment Item
            transferFormEditCtrl.toUnselect = equip.Id;
            transferFormEditCtrl.removeFromEquipmentList();
            
            transferFormEditCtrl.Save();
            
            
            request.From_Location__c = loc2.Id;
            request.To_Location__c = loc1.Id;
            
            //open the Equipment list page to select equipment
            pageRef = Page.EquipmentTransferItemSelection;
            Test.setCurrentPage(pageRef);
            pageRef.getParameters().put('fromLocId', request.From_Location__c);
            pageRef.getParameters().put('toLocId', request.To_Location__c);
            pageRef.getParameters().put('equipId', '');
            
            selectEquipCtrl = new EquipmentTransferItemSelectionController();
            System.assertEquals(selectEquipCtrl.AvailableEquips[0].Id, equip2.Id);
            
            //add equipment
            selectEquipCtrl.toSelect = equip2.Id;
            selectEquipCtrl.addToShoppingCart();
            selectEquipCtrl.onSave();
            transferFormEditCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
            transferFormEditCtrl.addToEquipmentList();
            
            
            system.assert(transferFormEditCtrl.equipmentList.size() > 0 );
            
            item = transferFormEditCtrl.equipmentList[0];
            item.equipment.Tag_Colour__c = 'Red';
            transferFormEditCtrl.save();
            transferFormEditCtrl.CloseRequest();
            
            request = [select id, Status__c from Equipment_Transfer_Form__c where Id =: request.Id];
            System.assertEquals(request.Status__c, 'Closed');
        }
    }
    
	static testMethod void testEquipmentTransferFacility()
	{
		User user = UserTestData.createTestUser();
        insert user;
		
        System.runAs(user)
        {		
			createSampleData();
			//create equipment for facility
			Facility__c fac1 = FacilityTestData.createFacility('Test Facility 1', route.Id, field.Id);
			Facility__c fac2 = FacilityTestData.createFacility('Test Facility 2', route.Id, field.Id);
			insert fac1;
			insert fac2;
			
			Equipment__c equip1 = EquipmentTestData.createEquipment(fac1);
			Equipment__c equip2 = EquipmentTestData.createEquipment(fac2);
			
			
			//test create a new Transfer Request from Loc2 to Loc1
	        PageReference pageRef = Page.EquipmentTransferFormEdit;
	        Test.setCurrentPage(pageRef);
	        pageRef.getParameters().put('fromFacId', fac1.Id);
	        
	        Equipment_Transfer_Form__c request = new Equipment_Transfer_Form__c();
	        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(request);
	        EquipmentTransferFormControllerX transferCtrl = new EquipmentTransferFormControllerX(stdCtrl);
	        request = transferCtrl.form;
	        request.Reason_for_Transfer_Additional_Details__c = 'NWC';
	        request.Date_of_Physical_Transfer__c = date.today();
			request.Authorized_By__c = user.id;
			
			transferCtrl.getDestinationObjects();
            transferCtrl.onSelectDestination();
            transferCtrl.getLocOutputFieldFlag();
            transferCtrl.getFacOutputFieldFlag();
            transferCtrl.getEventOutputFieldFlag();
            transferCtrl.getDestInputFieldFlag();
	        
	        try 
	        {
	        	transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	        	System.assert(false, 'You must enter a value for To(Destination)');
	        }
	        
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'Please select at least one Equipment.');
	        }
	            		
			
			//open the Manage Equipment page to select Equipment
	        pageRef = Page.EquipmentTransferItemSelection;
	        Test.setCurrentPage(pageRef);
	        pageRef.getParameters().put('fromFacId', request.From_Facility__c);
	        pageRef.getParameters().put('toFacId', request.To_Facility__c);
	        pageRef.getParameters().put('equipId', transferCtrl.equipIds);
	        EquipmentTransferItemSelectionController selectEquipCtrl = new EquipmentTransferItemSelectionController();
	        
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
	        //back to Equipment Transfer Edit page
	        selectEquipCtrl.onCancel();
	        
	        //test Form/To facility is required
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'You must enter a value');
	        }
	        request.To_Location__c = null;
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'You must enter a value');
	        }
	        //populate FROM Facility
	        request.From_Facility__c = fac1.Id;
	        request.To_Facility__c = fac2.Id;
	        
	        //open the Manage Equipment page again
	        pageRef.getParameters().put('fromFacId', request.From_Facility__c);
	        pageRef.getParameters().put('toFacId', request.To_Facility__c);
	        pageRef.getParameters().put('equipId', transferCtrl.equipIds);
	        selectEquipCtrl = new EquipmentTransferItemSelectionController();
	        
	        //should have one available Equipment 
	        System.assertEquals(selectEquipCtrl.AvailableEquips.size(), 1);
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
	
	        //add availble Equipment to shopping cart
	        selectEquipCtrl.toSelect = equip1.Id; 
	        selectEquipCtrl.addToShoppingCart();
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 1);
	        selectEquipCtrl.onSave();
	        
	        transferCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
	        transferCtrl.addToEquipmentList();
	        system.assertEquals(transferCtrl.equipmentList.size(), 1);
	        
	        
	        //change FROM facility = To facility
	        request.From_Facility__c = request.To_Facility__c;
	        
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false,'Form Facility has to be different from To Facility');
	        }
        }
		
	}    
	
	
	static testMethod void testEquipmentTransferEvent()
	{
		User user = UserTestData.createTestUser();
        insert user;
		
        System.runAs(user)
        {		
			createSampleData();
			
			//create locations for well event
            Location__c loc1 = LocationTestData.createLocation('Location Source 2', route.Id, field.Id);
            Location__c loc2 = LocationTestData.createLocation('Location Destination 2', route.Id, field.Id);
            insert loc1;
            insert loc2;

            //create well events
			Well_Event__c wellEvent1 = LocationTestData.createEvent('Test Well Event Source', loc1.Id);    
            Well_Event__c wellEvent2 = LocationTestData.createEvent('Test Well Event Destination', loc2.Id);    
            insert wellEvent1;
            insert wellEvent2;
			
			//create equipment for well event
			Equipment__c equip1 = EquipmentTestData.createEquipment(wellEvent1);
			Equipment__c equip2 = EquipmentTestData.createEquipment(wellEvent2);
			
			
			//test create a new Transfer Request from Loc2 to Loc1
	        PageReference pageRef = Page.EquipmentTransferFormEdit;
	        Test.setCurrentPage(pageRef);
	        pageRef.getParameters().put('toEventId', wellEvent2.Id);

	        
	        Equipment_Transfer_Form__c request = new Equipment_Transfer_Form__c();
	        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(request);
	        EquipmentTransferFormControllerX transferCtrl = new EquipmentTransferFormControllerX(stdCtrl);
	        request = transferCtrl.form;
	        request.Reason_for_Transfer_Additional_Details__c = 'NWC';
	        request.Date_of_Physical_Transfer__c = date.today();
			request.Authorized_By__c = user.id;
			
			System.assertEquals(request.To_Well_Event__c, wellEvent2.Id);
            System.assertEquals(request.From_Well_Event__c, null);
            //call getter methods 
            transferCtrl.getDestinationObjects();
            transferCtrl.onSelectDestination();
            transferCtrl.getLocOutputFieldFlag();
            transferCtrl.getFacOutputFieldFlag();
            transferCtrl.getEventOutputFieldFlag();
            transferCtrl.getDestInputFieldFlag();
	        
	        try 
	        {
	        	transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	        	System.assert(false, 'You must enter a value for To(Destination)');
	        }
	        
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'Please select at least one Equipment.');
	        }
	            		
			
			//open the Manage Equipment page to select Equipment
	        pageRef = Page.EquipmentTransferItemSelection;
	        Test.setCurrentPage(pageRef);
	        pageRef.getParameters().put('fromEventId', request.From_Well_Event__c);
	        pageRef.getParameters().put('toEventId', request.To_Well_Event__c);
	        pageRef.getParameters().put('equipId', transferCtrl.equipIds);
	        EquipmentTransferItemSelectionController selectEquipCtrl = new EquipmentTransferItemSelectionController();
	        
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
	        //back to Equipment Transfer Edit page
	        selectEquipCtrl.onCancel();
	        
	        //test Form/To Event is required
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'You must enter a value');
	        }
	        request.To_Well_Event__c = null;
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'You must enter a value');
	        }
	        //populate FROM Location
	        request.From_Well_Event__c = wellEvent1.Id;
	        request.To_Well_Event__c = wellEvent2.Id;
	        
	        //open the Manage Equipment page again
	        pageRef.getParameters().put('fromEventId', request.From_Well_Event__c);
	        pageRef.getParameters().put('toEventId', request.To_Well_Event__c);
	        pageRef.getParameters().put('equipId', transferCtrl.equipIds);
	        selectEquipCtrl = new EquipmentTransferItemSelectionController();
	        
	        //should have one available Equipment 
	        System.assertEquals(selectEquipCtrl.AvailableEquips.size(), 1);
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
	
	        //add availble Equipment to shopping cart
	        selectEquipCtrl.toSelect = equip1.Id; 
	        selectEquipCtrl.addToShoppingCart();
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 1);
	        selectEquipCtrl.onSave();
	        
	        transferCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
	        transferCtrl.addToEquipmentList();
	        system.assertEquals(transferCtrl.equipmentList.size(), 1);
	        
	        
	        //change FROM facility = To facility
	        request.From_Well_Event__c = request.To_Well_Event__c;
	        
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false,'From Well Event has to be different from To Well Event');
	        }
        }
		
	}
	
	static testMethod void testEquipmentTransferSystem()
	{
		User user = UserTestData.createTestUser();
        insert user;
		
        System.runAs(user)
        {		
			createSampleData();

            //create System
			System__c system1 = LocationTestData.createSystem('Test System Source');
			System__c system2 = LocationTestData.createSystem('Test System Destination');  
            //insert system1;
            //insert system2;
            
			//create equipment for System
			Equipment__c equip1 = EquipmentTestData.createEquipment(system1);
			Equipment__c equip2 = EquipmentTestData.createEquipment(system2);
			
			
			//test create a new Transfer Request from sys2 to sys1
	        PageReference pageRef = Page.EquipmentTransferFormEdit;
	        Test.setCurrentPage(pageRef);
	        pageRef.getParameters().put('toSystemId', system2.Id);

	        
	        Equipment_Transfer_Form__c request = new Equipment_Transfer_Form__c();
	        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(request);
	        EquipmentTransferFormControllerX transferCtrl = new EquipmentTransferFormControllerX(stdCtrl);
	        request = transferCtrl.form;
	        request.Reason_for_Transfer_Additional_Details__c = 'NWC';
	        request.Date_of_Physical_Transfer__c = date.today();
			request.Authorized_By__c = user.id;
			
			System.assertEquals(request.To_System__c, system2.Id);
            System.assertEquals(request.From_System__c, null);
            //call getter methods 
            transferCtrl.getDestinationObjects();
            transferCtrl.onSelectDestination();
            transferCtrl.getLocOutputFieldFlag();
            transferCtrl.getFacOutputFieldFlag();
            transferCtrl.getEventOutputFieldFlag();
            transferCtrl.getSystemOutputFieldFlag();
            transferCtrl.getSubSystemOutputFieldFlag();
            transferCtrl.getDestInputFieldFlag();
	        
	        try 
	        {
	        	transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	        	System.assert(false, 'You must enter a value for To(Destination)');
	        }
	        
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'Please select at least one Equipment.');
	        }
	            		
			
			//open the Manage Equipment page to select Equipment
	        pageRef = Page.EquipmentTransferItemSelection;
	        Test.setCurrentPage(pageRef);
	        pageRef.getParameters().put('fromSystemId', request.From_System__c);
	        pageRef.getParameters().put('toSystemId', request.To_System__c);
	        pageRef.getParameters().put('equipId', transferCtrl.equipIds);
	        EquipmentTransferItemSelectionController selectEquipCtrl = new EquipmentTransferItemSelectionController();
	        
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
	        //back to Equipment Transfer Edit page
	        selectEquipCtrl.onCancel();
	        
	        //test Form/To Event is required
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'You must enter a value');
	        }
	        request.To_System__c = null;
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'You must enter a value');
	        }
	        //populate FROM Location
	        request.From_System__c = system1.Id;
	        request.To_System__c = system2.Id;
	        
	        //open the Manage Equipment page again
	        pageRef.getParameters().put('fromSystemId', request.From_System__c);
	        pageRef.getParameters().put('toSystemId', request.To_System__c);
	        pageRef.getParameters().put('equipId', transferCtrl.equipIds);
	        selectEquipCtrl = new EquipmentTransferItemSelectionController();
	        
	        //should have one available Equipment 
	        System.assertEquals(selectEquipCtrl.AvailableEquips.size(), 1);
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
	
	        //add availble Equipment to shopping cart
	        selectEquipCtrl.toSelect = equip1.Id; 
	        selectEquipCtrl.addToShoppingCart();
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 1);
	        selectEquipCtrl.onSave();
	        
	        transferCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
	        transferCtrl.addToEquipmentList();
	        system.assertEquals(transferCtrl.equipmentList.size(), 1);
	        
	        
	        //change FROM system = To system
	        request.From_System__c = request.To_System__c;
	        
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false,'From System has to be different from To System');
	        }
        }
		
	}  
	
	static testMethod void testEquipmentTransferSubSystem()
	{
		User user = UserTestData.createTestUser();
        insert user;
		
        System.runAs(user)
        {		
			createSampleData();
			
            //create Sub-Systems
			Sub_System__c subSystem1 = LocationTestData.createSubSystem('Test Sub-System Source');    
            Sub_System__c subSystem2 = LocationTestData.createSubSystem('Test Sub-System Destination');    

			
			//create equipment for Sub-Systems
			Equipment__c equip1 = EquipmentTestData.createEquipment(subSystem1);
			Equipment__c equip2 = EquipmentTestData.createEquipment(subSystem2);
			
			
			//test create a new Transfer Request from Sys2 to Sys1
	        PageReference pageRef = Page.EquipmentTransferFormEdit;
	        Test.setCurrentPage(pageRef);
	        pageRef.getParameters().put('toSubSysId', subSystem2.Id);

	        
	        Equipment_Transfer_Form__c request = new Equipment_Transfer_Form__c();
	        ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(request);
	        EquipmentTransferFormControllerX transferCtrl = new EquipmentTransferFormControllerX(stdCtrl);
	        request = transferCtrl.form;
	        request.Reason_for_Transfer_Additional_Details__c = 'NWC';
	        request.Date_of_Physical_Transfer__c = date.today();
			request.Authorized_By__c = user.id;
			
			System.assertEquals(request.To_Sub_System__c, subSystem2.Id);
            System.assertEquals(request.From_Sub_System__c, null);
            //call getter methods 
            transferCtrl.getDestinationObjects();
            transferCtrl.onSelectDestination();
            transferCtrl.getLocOutputFieldFlag();
            transferCtrl.getFacOutputFieldFlag();
            transferCtrl.getEventOutputFieldFlag();
            transferCtrl.getSystemOutputFieldFlag();
            transferCtrl.getSubSystemOutputFieldFlag();
            transferCtrl.getDestInputFieldFlag();
	        
	        try 
	        {
	        	transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	        	System.assert(false, 'You must enter a value for To(Destination)');
	        }
	        
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'Please select at least one Equipment.');
	        }
	            		
			
			//open the Manage Equipment page to select Equipment
	        pageRef = Page.EquipmentTransferItemSelection;
	        Test.setCurrentPage(pageRef);
	        pageRef.getParameters().put('fromSubSysId', request.From_Sub_System__c);
	        pageRef.getParameters().put('toSubSysId', request.To_Sub_System__c);
	        pageRef.getParameters().put('equipId', transferCtrl.equipIds);
	        EquipmentTransferItemSelectionController selectEquipCtrl = new EquipmentTransferItemSelectionController();
	        
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
	        //back to Equipment Transfer Edit page
	        selectEquipCtrl.onCancel();
	        
	        //test Form/To Event is required
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'You must enter a value');
	        }
	        request.To_Sub_System__c = null;
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false, 'You must enter a value');
	        }
	        //populate FROM Sub-System
	        request.From_Sub_System__c = subSystem1.Id;
	        request.To_Sub_System__c = subSystem2.Id;
	        
	        //open the Manage Equipment page again
	        pageRef.getParameters().put('fromSubSysId', request.From_Sub_System__c);
	        pageRef.getParameters().put('toSubSysId', request.To_Sub_System__c);
	        pageRef.getParameters().put('equipId', transferCtrl.equipIds);
	        selectEquipCtrl = new EquipmentTransferItemSelectionController();
	        
	        //should have one available Equipment 
	        System.assertEquals(selectEquipCtrl.AvailableEquips.size(), 1);
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
	
	        //add availble Equipment to shopping cart
	        selectEquipCtrl.toSelect = equip1.Id; 
	        selectEquipCtrl.addToShoppingCart();
	        System.assertEquals(selectEquipCtrl.shoppingCart.size(), 1);
	        selectEquipCtrl.onSave();
	        
	        transferCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
	        transferCtrl.addToEquipmentList();
	        system.assertEquals(transferCtrl.equipmentList.size(), 1);
	        
	        
	        //change FROM SubSystem = To SubSystem
	        request.From_Sub_System__c = request.To_Sub_System__c;
	        
	        try
	        {
	            transferCtrl.Save();
	        }
	        catch(Exception e)
	        {
	            System.assert(false,'From Sub-System has to be different from To Sub-System');
	        }
        }
		
	}  

    static testMethod void testEquipmentTransferFEL()
    {
        User user = UserTestData.createTestUser();
        insert user;
        
        System.runAs(user)
        {       
            createSampleData();

            //create System
            Functional_Equipment_Level__c fel1 = LocationTestData.createFEL('Test FEL Source');
            Functional_Equipment_Level__c fel2 = LocationTestData.createFEL('Test FEL Destination');  
            
            
            //create equipment for System
            Equipment__c equip1 = EquipmentTestData.createEquipment(fel1);
            Equipment__c equip2 = EquipmentTestData.createEquipment(fel2);
            
            
            //test create a new Transfer Request from sys2 to sys1
            PageReference pageRef = Page.EquipmentTransferFormEdit;
            Test.setCurrentPage(pageRef);
            pageRef.getParameters().put('toFELId', fel2.Id);

            
            Equipment_Transfer_Form__c request = new Equipment_Transfer_Form__c();
            ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(request);
            EquipmentTransferFormControllerX transferCtrl = new EquipmentTransferFormControllerX(stdCtrl);
            request = transferCtrl.form;
            request.Reason_for_Transfer_Additional_Details__c = 'NWC';
            request.Date_of_Physical_Transfer__c = date.today();
            request.Authorized_By__c = user.id;
            
            System.assertEquals(request.To_Functional_Equipment_Level__c, fel2.Id);
            System.assertEquals(request.From_Functional_Equipment_Level__c, null);
            //call getter methods 
            transferCtrl.getDestinationObjects();
            transferCtrl.onSelectDestination();
            transferCtrl.getLocOutputFieldFlag();
            transferCtrl.getFacOutputFieldFlag();
            transferCtrl.getEventOutputFieldFlag();
            transferCtrl.getSystemOutputFieldFlag();
            transferCtrl.getSubSystemOutputFieldFlag();
            transferCtrl.getDestInputFieldFlag();
            transferCtrl.getFELOutputFieldFlag();
            transferCtrl.getYardOutputFieldFlag();
            try 
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value for To(Destination)');
            }
            
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'Please select at least one Equipment.');
            }
                        
            
            //open the Manage Equipment page to select Equipment
            pageRef = Page.EquipmentTransferItemSelection;
            Test.setCurrentPage(pageRef);
            pageRef.getParameters().put('fromFELId', request.From_Functional_Equipment_Level__c);
            pageRef.getParameters().put('toFELId', request.To_Functional_Equipment_Level__c);
            pageRef.getParameters().put('equipId', transferCtrl.equipIds);
            EquipmentTransferItemSelectionController selectEquipCtrl = new EquipmentTransferItemSelectionController();
            
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
            //back to Equipment Transfer Edit page
            selectEquipCtrl.onCancel();
            
            //test Form/To Event is required
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            request.To_Functional_Equipment_Level__c = null;
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            //populate FROM Location
            request.From_Functional_Equipment_Level__c = fel1.Id;
            request.To_Functional_Equipment_Level__c = fel2.Id;
            
            //open the Manage Equipment page again
            pageRef.getParameters().put('fromFELId', request.From_Functional_Equipment_Level__c);
            pageRef.getParameters().put('toFELId', request.To_Functional_Equipment_Level__c);
            pageRef.getParameters().put('equipId', transferCtrl.equipIds);
            selectEquipCtrl = new EquipmentTransferItemSelectionController();
            
            //should have one available Equipment 
            System.assertEquals(selectEquipCtrl.AvailableEquips.size(), 1);
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
    
            //add availble Equipment to shopping cart
            selectEquipCtrl.toSelect = equip1.Id; 
            selectEquipCtrl.addToShoppingCart();
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 1);
            selectEquipCtrl.onSave();
            
            transferCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
            transferCtrl.addToEquipmentList();
            system.assertEquals(transferCtrl.equipmentList.size(), 1);
            
            request.From_Functional_Equipment_Level__c = request.To_Functional_Equipment_Level__c;
            
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false,'From System has to be different from To System');
            }
        }
        
    }  

    static testMethod void testEquipmentTransferYard()
    {
        User user = UserTestData.createTestUser();
        insert user;
        
        System.runAs(user)
        {       
            createSampleData();

            //create System
            Yard__c yard1 = LocationTestData.createYard('Test Yard Source');
            Yard__c yard2 = LocationTestData.createYard('Test Yard Destination');  
            
            
            //create equipment for System
            Equipment__c equip1 = EquipmentTestData.createEquipment(yard1);
            Equipment__c equip2 = EquipmentTestData.createEquipment(yard2);
            
            
            //test create a new Transfer Request from sys2 to sys1
            PageReference pageRef = Page.EquipmentTransferFormEdit;
            Test.setCurrentPage(pageRef);
            pageRef.getParameters().put('toYardId', yard2.Id);

            
            Equipment_Transfer_Form__c request = new Equipment_Transfer_Form__c();
            ApexPages.Standardcontroller stdCtrl = new ApexPages.Standardcontroller(request);
            EquipmentTransferFormControllerX transferCtrl = new EquipmentTransferFormControllerX(stdCtrl);
            request = transferCtrl.form;
            request.Reason_for_Transfer_Additional_Details__c = 'NWC';
            request.Date_of_Physical_Transfer__c = date.today();
            request.Authorized_By__c = user.id;
            
            System.assertEquals(request.To_Yard__c, yard2.Id);
            System.assertEquals(request.From_Yard__c, null);
            //call getter methods 
            transferCtrl.getDestinationObjects();
            transferCtrl.onSelectDestination();
            transferCtrl.getLocOutputFieldFlag();
            transferCtrl.getFacOutputFieldFlag();
            transferCtrl.getEventOutputFieldFlag();
            transferCtrl.getSystemOutputFieldFlag();
            transferCtrl.getSubSystemOutputFieldFlag();
            transferCtrl.getDestInputFieldFlag();
            transferCtrl.getFELOutputFieldFlag();
            transferCtrl.getYardOutputFieldFlag();
            try 
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value for To(Destination)');
            }
            
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'Please select at least one Equipment.');
            }
                        
            
            //open the Manage Equipment page to select Equipment
            pageRef = Page.EquipmentTransferItemSelection;
            Test.setCurrentPage(pageRef);
            pageRef.getParameters().put('fromYardId', request.From_Yard__c);
            pageRef.getParameters().put('toYardId', request.To_Yard__c);
            pageRef.getParameters().put('equipId', transferCtrl.equipIds);
            EquipmentTransferItemSelectionController selectEquipCtrl = new EquipmentTransferItemSelectionController();
            
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
            //back to Equipment Transfer Edit page
            selectEquipCtrl.onCancel();
            
            //test Form/To Event is required
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            request.To_Yard__c = null;
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false, 'You must enter a value');
            }
            //populate FROM Location
            request.From_Yard__c = yard1.Id;
            request.To_Yard__c = yard2.Id;
            
            //open the Manage Equipment page again
            pageRef.getParameters().put('fromYardId', request.From_Yard__c);
            pageRef.getParameters().put('toYardId', request.To_Yard__c);
            pageRef.getParameters().put('equipId', transferCtrl.equipIds);
            selectEquipCtrl = new EquipmentTransferItemSelectionController();
            
            //should have one available Equipment 
            System.assertEquals(selectEquipCtrl.AvailableEquips.size(), 1);
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 0);
    
            //add availble Equipment to shopping cart
            selectEquipCtrl.toSelect = equip1.Id; 
            selectEquipCtrl.addToShoppingCart();
            System.assertEquals(selectEquipCtrl.shoppingCart.size(), 1);
            selectEquipCtrl.onSave();
            
            transferCtrl.toSelectIds = selectEquipCtrl.selectedEquipIds;
            transferCtrl.addToEquipmentList();
            system.assertEquals(transferCtrl.equipmentList.size(), 1);
            
            request.From_Yard__c = request.To_Yard__c;
            
            try
            {
                transferCtrl.Save();
            }
            catch(Exception e)
            {
                System.assert(false,'From System has to be different from To System');
            }
        }
        
    }  
	
    //test bulk close Equipment Transfer Requests
    static testMethod void testEquipmentTransferRequestBulkClose()
    {

        User sapSupportLeadUser = EquipmentTestData.createUser('SAP Support - Lead','Standard HOG - General User','SAP_Support_LeadUser@test.com'); 

        System.runAs(sapSupportLeadUser)
        {
            createSampleData();
            Location__c loc1 = LocationTestData.createLocation('Location Source', route.Id, field.Id);
            insert loc1;
            Equipment__c equip = EquipmentTestData.createEquipment(loc1);
            
            Location__c loc2 = LocationTestData.createLocation('Location Destination', route.Id, field.Id);
            insert loc2;
            
             
            //create bulk of "Open" Equipment Transfer Request form for location
            List<Equipment_Transfer_Form__c> formList = new List<Equipment_Transfer_Form__c>();
            for(integer i=0; i< 3; i++)
            {
                Equipment_Transfer_Form__c form = new Equipment_Transfer_Form__c();
                form.From_Location__c = loc1.Id;
                form.To_Location__c = loc2.Id;
                form.Status__c = 'Open';
                form.Reason_for_Transfer_Additional_Details__c = 'NWC';
                form.Date_of_Physical_Transfer__c = date.today();
                form.Authorized_By__c = sapSupportLeadUser.Id;
                
                formList.add(form);
            }
            
            /*//create bulk of "Open Equipment Transfer Request form for facilities
            for(integer i=0; i< 3; i++)
            {
                Equipment_Transfer_Form__c form = new Equipment_Transfer_Form__c();
                form.From_Location__c = loc1.Id;
                form.To_Location__c = loc2.Id;
                form.Status__c = 'Open';
                form.Reason_for_Transfer_Additional_Details__c = 'NWC';
                form.Date_of_Physical_Transfer__c = date.today();
                form.Authorized_By__c = user.Id;
                
                formList.add(form);
            } */           
            
            insert formList;
      
            
            formList = [select Id, Authorized_By__c, Comments__c, Date_of_Physical_Transfer__c, Charge_No__c, From_Location__c, 
                        Maintenance_Work_Order__c, Reason_for_Transfer_Additional_Details__c, Shipped_Via__c, Status__c, 
                        To_Location__c, Waybill_No__c 
                        from Equipment_Transfer_Form__c where From_Location__c =: loc1.Id];
            
            Equipment_Transfer_Item__c transferItem = new Equipment_Transfer_Item__c();
            transferItem.Equipment__c = equip.Id;
            transferItem.Equipment_Transfer_Form__c = formList[0].Id;
            transferItem.Tag_Colour__c = 'Red';
            insert transferItem;
                        
            ApexPages.StandardSetController stdcon = new ApexPages.StandardSetController(formList);
            EquipmentTransferFormBulkCloseController setCtrl;
            //display error when no Form is selected
            try
            {
                setCtrl = new EquipmentTransferFormBulkCloseController(stdcon);
            }
            catch(Exception e)
            {
                System.assert(false, 'Please select at least one Equipment Transfer Form');
            }
            stdcon.SetSelected(formList);    
            setCtrl = new EquipmentTransferFormBulkCloseController(stdcon);
            
            system.assertEquals(1, setCtrl.CurrentIndex); 
            system.assertNotEquals(null, setCtrl.CurrentForm); 
            system.assertEquals(3, setCtrl.selectedList.Size()); 
                
                
            Equipment_Transfer_Form__c CurrentForm = setCtrl.CurrentForm;
            System.assert(setCtrl.equipmentList.size() > 0);
            
            Equipment_Transfer_Form__c Form2 = setCtrl.selectedList[1];
            Equipment_Transfer_Form__c Form3 = setCtrl.selectedList[2];
                
            system.assertEquals(false, setCtrl.getHasPreviousForm()); 
            system.assertEquals(true, setCtrl.getHasNextForm());            
    
            setCtrl.NextForm();
            system.assertEquals(2, setCtrl.CurrentIndex); 
            system.assertEquals(Form2 , setCtrl.CurrentForm); 
            system.assertEquals(true, setCtrl.getHasPreviousForm()); 
            system.assertEquals(true, setCtrl.getHasNextForm()); 
    
            setCtrl.NextForm();
            system.assertEquals(3, setCtrl.CurrentIndex);             
            system.assertEquals(Form3 , setCtrl.CurrentForm); 
            system.assertEquals(true, setCtrl.getHasPreviousForm()); 
            system.assertEquals(false, setCtrl.getHasNextForm());                        
    
            //lets try to go over the last form
            setCtrl.NextForm();
            system.assertEquals(3, setCtrl.CurrentIndex); //still 3            
            system.assertEquals(Form3 , setCtrl.CurrentForm); 
            system.assertEquals(true, setCtrl.getHasPreviousForm()); 
            system.assertEquals(false, setCtrl.getHasNextForm());  
    
            setCtrl.PreviousForm();
            system.assertEquals(2, setCtrl.CurrentIndex); 
            system.assertEquals(Form2 , setCtrl.CurrentForm); 
            system.assertEquals(true, setCtrl.getHasPreviousForm()); 
            system.assertEquals(true, setCtrl.getHasNextForm()); 
                
            setCtrl.CloseForm();
            Form2 = [select Id, Status__c from Equipment_Transfer_Form__c where Id=: Form2.id];
            System.assertEquals(Form2.Status__c, 'Closed');
            
        }
    }
    
    
        static testMethod void testEquipmentTransferRequestBulkCloseNonSAPSupportuser()
    {
        
        //user is not SAP Support Lead - will fail
        User HOGUser = EquipmentTestData.createUser('Heavy Oil & Gas','Standard HOG - General User','SAP_Support_LeadUser@test.com'); 

        System.runAs(HOGUser)
        {
            createSampleData();
            Location__c loc1 = LocationTestData.createLocation('Location Source', route.Id, field.Id);
            insert loc1;
            Equipment__c equip = EquipmentTestData.createEquipment(loc1);
            
            Location__c loc2 = LocationTestData.createLocation('Location Destination', route.Id, field.Id);
            insert loc2;
            
             
            //create bulk of "Open" Equipment Transfer Request form for location
            List<Equipment_Transfer_Form__c> formList = new List<Equipment_Transfer_Form__c>();
            for(integer i=0; i< 3; i++)
            {
                Equipment_Transfer_Form__c form = new Equipment_Transfer_Form__c();
                form.From_Location__c = loc1.Id;
                form.To_Location__c = loc2.Id;
                form.Status__c = 'Open';
                form.Reason_for_Transfer_Additional_Details__c = 'NWC';
                form.Date_of_Physical_Transfer__c = date.today();
                form.Authorized_By__c = HOGUser.Id;
                
                formList.add(form);
            }
            
            insert formList;
      
            
            formList = [select Id, Authorized_By__c, Comments__c, Date_of_Physical_Transfer__c, Charge_No__c, From_Location__c, 
                        Maintenance_Work_Order__c, Reason_for_Transfer_Additional_Details__c, Shipped_Via__c, Status__c, 
                        To_Location__c, Waybill_No__c 
                        from Equipment_Transfer_Form__c where From_Location__c =: loc1.Id];
            
            Equipment_Transfer_Item__c transferItem = new Equipment_Transfer_Item__c();
            transferItem.Equipment__c = equip.Id;
            transferItem.Equipment_Transfer_Form__c = formList[0].Id;
            transferItem.Tag_Colour__c = 'Red';
            insert transferItem;
                        
            ApexPages.StandardSetController stdcon = new ApexPages.StandardSetController(formList);
            EquipmentTransferFormBulkCloseController setCtrl;
            //display error when no Form is selected
            try
            {
                setCtrl = new EquipmentTransferFormBulkCloseController(stdcon);
            }
            catch(Exception e)
            {
                System.assert(false, 'Please select at least one Equipment Transfer Form');
            }
            stdcon.SetSelected(formList);    
            setCtrl = new EquipmentTransferFormBulkCloseController(stdcon);
            
            List<Apexpages.Message> msgs = ApexPages.getMessages();
            boolean b = false;
            
            for (Apexpages.Message msg : msgs){
                 
                if (msg.getDetail().contains('Only SAP Support Lead, HOG - Administrator or System Administrator can process.')){ 
                    
                    b = true;
                }
            }
            
            system.assert(b);   //Assert the Page Message was Properly Displayed
       
        }
    }
    
}